/* $Header: /u/spert/src/fltvec/RCS/fltv-defs.h,v 1.5 1996/04/04 01:11:45 davidj Exp $ */

/* Work out how to find alloca - see the autoconf docs for more details */
#ifdef __GNUC__
#define alloca __builtin_alloca
#else
#ifdef FLTV_HAVE_ALLOCA_H
#include <alloca.h>
#endif
#endif

#ifndef FLTV_BITS_CHAR
#define FLTV_BITS_CHAR (8)
#endif

#ifndef FLTV_BITS_SHORT
#define FLTV_BITS_SHORT (16)
#endif

#ifndef FLTV_BITS_INT
#define FLTV_BITS_INT (32)
#endif

#if (FLTV_BITS_CHAR==8)
# if defined(__STDC__) || defined(__cplusplus)
typedef signed char fltv_int8_t;
# else
typedef char fltv_int8_t;
# endif
typedef unsigned char fltv_uint8_t;
#define FLTV_INT8_MIN (-0x80)
#define FLTV_INT8_MAX (0x7f)
#define FLTV_UINT8_MIN (0)
#define FLTV_UINT8_MAX (0xff)
#else
#error We need an 8 bit type
#endif

#if (FLTV_BITS_SHORT==16)
typedef short fltv_int16_t;
typedef unsigned short fltv_uint16_t;
#define FLTV_INT16_MIN (-0x8000)
#define FLTV_INT16_MAX (0x7fff)
#define FLTV_UINT16_MIN (0)
#define FLTV_UINT16_MAX (0xffff)
#else
#error We need a 16 bit type
#endif

#if (FLTV_BITS_INT==32)
typedef int fltv_int32_t;
typedef unsigned int fltv_uint32_t;
#define FLTV_INT32_MIN (-0x7fffffff-1)
#define FLTV_INT32_MAX (0x7fffffff)
#define FLTV_UINT32_MIN (0)
#define FLTV_UINT32_MAX (0xffffffffu)
#else
#error We need a 32 bit type
#endif

typedef union { float f; fltv_int32_t i; } fltv_float_int32_t;

typedef int fltv_bool_t;
#define FLTV_FALSE (0)
#define FLTV_TRUE (1)

#define FLTV_SIZET_BAD (0xfffffffful)

/* Some useful constants */

#define FLTV_E          2.7182818284590452354
#define FLTV_LOG2E      1.4426950408889634074
#define FLTV_LOG10E     0.43429448190325182765
#define FLTV_LN2        0.69314718055994530942
#define FLTV_LN10       2.30258509299404568402
#define FLTV_PI         3.14159265358979323846
#define FLTV_PI_2       1.57079632679489661923
#define FLTV_PI_4       0.78539816339744830962
#define FLTV_1_PI       0.31830988618379067154
#define FLTV_2_PI       0.63661977236758134308
#define FLTV_2_SQRTPI   1.12837916709551257390
#define FLTV_SQRT2      1.41421356237309504880
#define FLTV_SQRT1_2    0.70710678118654752440
