/*
** $Header: /u/spert/src/fltvec/nfp/RCS/scalar.c,v 1.2 1996/04/10 23:28:38 davidj Exp $
**
** Floating point scalar operations - using as little floating point as
** possible
*/

#include <fltv-config.h>
#include <stddef.h>
#include <fltv-defs.h>
#include <fltv-scansrc.h>

#ifdef DECL_nfp_isnan_f_b
/*
** Check whether a signle precision floating point number is a NaN.
** Uses integer operations.
*/
fltv_bool_t nfp_isnan_f_b(float f);
#endif

#ifdef DEFN_nfp_isnan_f_b
fltv_bool_t
nfp_isnan_f_b(float f)
{
    union {
	float f;
	fltv_uint32_t u;
    } v;
    fltv_uint32_t u;

    v.f = f;
    u = v.u;

    if ((u & 0x7f800000u)==0x7f800000u && (u&0x007fffff)!=0)
	return(FLTV_TRUE);
    else
	return(FLTV_FALSE);
}
#endif

#ifdef DECL_nfp_isnan_d_b
/*
** Check whether a double precision floating point number is a NaN
** Uses integer operations.
*/
fltv_bool_t nfp_isnan_d_b(double d);
#endif

#ifdef DEFN_nfp_isnan_d_b
fltv_bool_t
nfp_isnan_d_b(double d)
{
    union {
	double d;
	struct
	{
	    fltv_uint32_t u1;
	    fltv_uint32_t u2;
	} u;
    } v;
    fltv_uint32_t u1;
    fltv_uint32_t u2;

    v.d = d;
    u1 = v.u.u1;
    u2 = v.u.u2;

    if ((u1 & 0x7ff00000u)==0x7ff00000u &&
	((u1&0x000fffff)!=0 || (u2!=0)) )
	return(FLTV_TRUE);
    else
	return(FLTV_FALSE);
}

#endif

