/* Version: $Header: /u/spert/src/fltvec/php/RCS/multtacc_mfmf_mf.c,v 1.2 1995/10/13 00:16:32 davidj Exp $ */

#include <fltv-config.h>
#include <stddef.h>
#include <fltv-defs.h>
#include <fltv-scansrc.h>


#ifdef DECL_php_multtacc_mfmf_mf
void php_multtacc_mfmf_mf(size_t a_rows, size_t a_cols, size_t b_rows,
			  const float* a, const float* b, float* res);
#endif

/*
**
** Matrix-Matrix Code for the operation:
**    C = transpose(A)*transpose(B) + C
**
** Automatically Generated by mm_gen ($Revision: 1.2 $) using the command:
**    /n/burrito/da/bilmes/phipac/mm_gen/mm_gen -cb 2 4 10 -cb 26 13 5 -file /tmp/dj -prec single -routine_name _multtacc_mfmf_mf -alpha 1 -beta 1 -opA t -opB t 
**
** Generated on: Thursday June 22 1995, 21:03:59 PDT
** Created by: Jeff Bilmes <bilmes@cs.berkeley.edu>
**
*/

#define LOAD1x1(c00,C,Cstride) \
{\
   float * _cp = C; \
   c00 = _cp[0]; \
}

#define STORE1x1(c00,C,Cstride) \
{\
   float *_cp = C; \
   _cp[0] = c00; \
}

/* Fixed M,K,N = 1,1,1 matrix matrix multiply. */
#define mul_tmf1x1tmf1x1_mf1x1(c00,A,Astride,B0) \
{ \
   register float _a0; \
   register float _b; \
   \
   \
   _a0 = A[0]; \
   A += Astride; \
   _b = B0[0]; \
   c00 += _b*_a0; \
}


/* Fixed M,K,N = 1,2,1 matrix matrix multiply. */
#define mul_tmf1x2tmf2x1_mf1x1(c00,A,Astride,B0) \
{ \
   register float _a0; \
   register float _b; \
   \
   \
   _a0 = A[0]; \
   A += Astride; \
   _b = B0[0]; \
   c00 += _b*_a0; \
   \
   _a0 = A[0]; \
   A += Astride; \
   _b = B0[1]; \
   c00 += _b*_a0; \
}


/* Fixed M,K,N = 1,4,1 matrix matrix multiply. */
#define mul_tmf1x4tmf4x1_mf1x1(c00,A,Astride,B0) \
{ \
   register float _a0; \
   register float _b; \
   \
   \
   _a0 = A[0]; \
   A += Astride; \
   _b = B0[0]; \
   c00 += _b*_a0; \
   \
   _a0 = A[0]; \
   A += Astride; \
   _b = B0[1]; \
   c00 += _b*_a0; \
   \
   _a0 = A[0]; \
   A += Astride; \
   _b = B0[2]; \
   c00 += _b*_a0; \
   \
   _a0 = A[0]; \
   A += Astride; \
   _b = B0[3]; \
   c00 += _b*_a0; \
}


#define LOAD1x2(c00,c01,C,Cstride) \
{\
   float * _cp = C; \
   c00 = _cp[0]; c01 = _cp[1]; \
}

#define STORE1x2(c00,c01,C,Cstride) \
{\
   float *_cp = C; \
   _cp[0] = c00; _cp[1] = c01; \
}

/* Fixed M,K,N = 1,1,2 matrix matrix multiply. */
#define mul_tmf1x1tmf1x2_mf1x2(c00,c01,A,Astride,B0,B1) \
{ \
   register float _a0; \
   register float _b; \
   \
   \
   _a0 = A[0]; \
   A += Astride; \
   _b = B0[0]; \
   c00 += _b*_a0; \
   _b = B1[0]; \
   c01 += _b*_a0; \
}


/* Fixed M,K,N = 1,2,2 matrix matrix multiply. */
#define mul_tmf1x2tmf2x2_mf1x2(c00,c01,A,Astride,B0,B1) \
{ \
   register float _a0; \
   register float _b; \
   \
   \
   _a0 = A[0]; \
   A += Astride; \
   _b = B0[0]; \
   c00 += _b*_a0; \
   _b = B1[0]; \
   c01 += _b*_a0; \
   \
   _a0 = A[0]; \
   A += Astride; \
   _b = B0[1]; \
   c00 += _b*_a0; \
   _b = B1[1]; \
   c01 += _b*_a0; \
}


/* Fixed M,K,N = 1,4,2 matrix matrix multiply. */
#define mul_tmf1x4tmf4x2_mf1x2(c00,c01,A,Astride,B0,B1) \
{ \
   register float _a0; \
   register float _b; \
   \
   \
   _a0 = A[0]; \
   A += Astride; \
   _b = B0[0]; \
   c00 += _b*_a0; \
   _b = B1[0]; \
   c01 += _b*_a0; \
   \
   _a0 = A[0]; \
   A += Astride; \
   _b = B0[1]; \
   c00 += _b*_a0; \
   _b = B1[1]; \
   c01 += _b*_a0; \
   \
   _a0 = A[0]; \
   A += Astride; \
   _b = B0[2]; \
   c00 += _b*_a0; \
   _b = B1[2]; \
   c01 += _b*_a0; \
   \
   _a0 = A[0]; \
   A += Astride; \
   _b = B0[3]; \
   c00 += _b*_a0; \
   _b = B1[3]; \
   c01 += _b*_a0; \
}


#define LOAD1x4(c00,c01,c02,c03,C,Cstride) \
{\
   float * _cp = C; \
   c00 = _cp[0]; c01 = _cp[1]; c02 = _cp[2]; c03 = _cp[3]; \
}

#define STORE1x4(c00,c01,c02,c03,C,Cstride) \
{\
   float *_cp = C; \
   _cp[0] = c00; _cp[1] = c01; _cp[2] = c02; _cp[3] = c03; \
}

/* Fixed M,K,N = 1,1,4 matrix matrix multiply. */
#define mul_tmf1x1tmf1x4_mf1x4(c00,c01,c02,c03,A,Astride,B0,B1,B2,B3) \
{ \
   register float _a0; \
   register float _b; \
   \
   \
   _a0 = A[0]; \
   A += Astride; \
   _b = B0[0]; \
   c00 += _b*_a0; \
   _b = B1[0]; \
   c01 += _b*_a0; \
   _b = B2[0]; \
   c02 += _b*_a0; \
   _b = B3[0]; \
   c03 += _b*_a0; \
}


/* Fixed M,K,N = 1,2,4 matrix matrix multiply. */
#define mul_tmf1x2tmf2x4_mf1x4(c00,c01,c02,c03,A,Astride,B0,B1,B2,B3) \
{ \
   register float _a0; \
   register float _b; \
   \
   \
   _a0 = A[0]; \
   A += Astride; \
   _b = B0[0]; \
   c00 += _b*_a0; \
   _b = B1[0]; \
   c01 += _b*_a0; \
   _b = B2[0]; \
   c02 += _b*_a0; \
   _b = B3[0]; \
   c03 += _b*_a0; \
   \
   _a0 = A[0]; \
   A += Astride; \
   _b = B0[1]; \
   c00 += _b*_a0; \
   _b = B1[1]; \
   c01 += _b*_a0; \
   _b = B2[1]; \
   c02 += _b*_a0; \
   _b = B3[1]; \
   c03 += _b*_a0; \
}


/* Fixed M,K,N = 1,4,4 matrix matrix multiply. */
#define mul_tmf1x4tmf4x4_mf1x4(c00,c01,c02,c03,A,Astride,B0,B1,B2,B3) \
{ \
   register float _a0; \
   register float _b; \
   \
   \
   _a0 = A[0]; \
   A += Astride; \
   _b = B0[0]; \
   c00 += _b*_a0; \
   _b = B1[0]; \
   c01 += _b*_a0; \
   _b = B2[0]; \
   c02 += _b*_a0; \
   _b = B3[0]; \
   c03 += _b*_a0; \
   \
   _a0 = A[0]; \
   A += Astride; \
   _b = B0[1]; \
   c00 += _b*_a0; \
   _b = B1[1]; \
   c01 += _b*_a0; \
   _b = B2[1]; \
   c02 += _b*_a0; \
   _b = B3[1]; \
   c03 += _b*_a0; \
   \
   _a0 = A[0]; \
   A += Astride; \
   _b = B0[2]; \
   c00 += _b*_a0; \
   _b = B1[2]; \
   c01 += _b*_a0; \
   _b = B2[2]; \
   c02 += _b*_a0; \
   _b = B3[2]; \
   c03 += _b*_a0; \
   \
   _a0 = A[0]; \
   A += Astride; \
   _b = B0[3]; \
   c00 += _b*_a0; \
   _b = B1[3]; \
   c01 += _b*_a0; \
   _b = B2[3]; \
   c02 += _b*_a0; \
   _b = B3[3]; \
   c03 += _b*_a0; \
}


#define LOAD1x8(c00,c01,c02,c03,c04,c05,c06,c07,C,Cstride) \
{\
   float * _cp = C; \
   c00 = _cp[0]; c01 = _cp[1]; c02 = _cp[2]; c03 = _cp[3]; c04 = _cp[4]; c05 = _cp[5]; c06 = _cp[6]; c07 = _cp[7]; \
}

#define STORE1x8(c00,c01,c02,c03,c04,c05,c06,c07,C,Cstride) \
{\
   float *_cp = C; \
   _cp[0] = c00; _cp[1] = c01; _cp[2] = c02; _cp[3] = c03; _cp[4] = c04; _cp[5] = c05; _cp[6] = c06; _cp[7] = c07; \
}

/* Fixed M,K,N = 1,1,8 matrix matrix multiply. */
#define mul_tmf1x1tmf1x8_mf1x8(c00,c01,c02,c03,c04,c05,c06,c07,A,Astride,B0,B1,B2,B3,B4,B5,B6,B7) \
{ \
   register float _a0; \
   register float _b; \
   \
   \
   _a0 = A[0]; \
   A += Astride; \
   _b = B0[0]; \
   c00 += _b*_a0; \
   _b = B1[0]; \
   c01 += _b*_a0; \
   _b = B2[0]; \
   c02 += _b*_a0; \
   _b = B3[0]; \
   c03 += _b*_a0; \
   _b = B4[0]; \
   c04 += _b*_a0; \
   _b = B5[0]; \
   c05 += _b*_a0; \
   _b = B6[0]; \
   c06 += _b*_a0; \
   _b = B7[0]; \
   c07 += _b*_a0; \
}


/* Fixed M,K,N = 1,2,8 matrix matrix multiply. */
#define mul_tmf1x2tmf2x8_mf1x8(c00,c01,c02,c03,c04,c05,c06,c07,A,Astride,B0,B1,B2,B3,B4,B5,B6,B7) \
{ \
   register float _a0; \
   register float _b; \
   \
   \
   _a0 = A[0]; \
   A += Astride; \
   _b = B0[0]; \
   c00 += _b*_a0; \
   _b = B1[0]; \
   c01 += _b*_a0; \
   _b = B2[0]; \
   c02 += _b*_a0; \
   _b = B3[0]; \
   c03 += _b*_a0; \
   _b = B4[0]; \
   c04 += _b*_a0; \
   _b = B5[0]; \
   c05 += _b*_a0; \
   _b = B6[0]; \
   c06 += _b*_a0; \
   _b = B7[0]; \
   c07 += _b*_a0; \
   \
   _a0 = A[0]; \
   A += Astride; \
   _b = B0[1]; \
   c00 += _b*_a0; \
   _b = B1[1]; \
   c01 += _b*_a0; \
   _b = B2[1]; \
   c02 += _b*_a0; \
   _b = B3[1]; \
   c03 += _b*_a0; \
   _b = B4[1]; \
   c04 += _b*_a0; \
   _b = B5[1]; \
   c05 += _b*_a0; \
   _b = B6[1]; \
   c06 += _b*_a0; \
   _b = B7[1]; \
   c07 += _b*_a0; \
}


/* Fixed M,K,N = 1,4,8 matrix matrix multiply. */
#define mul_tmf1x4tmf4x8_mf1x8(c00,c01,c02,c03,c04,c05,c06,c07,A,Astride,B0,B1,B2,B3,B4,B5,B6,B7) \
{ \
   register float _a0; \
   register float _b; \
   \
   \
   _a0 = A[0]; \
   A += Astride; \
   _b = B0[0]; \
   c00 += _b*_a0; \
   _b = B1[0]; \
   c01 += _b*_a0; \
   _b = B2[0]; \
   c02 += _b*_a0; \
   _b = B3[0]; \
   c03 += _b*_a0; \
   _b = B4[0]; \
   c04 += _b*_a0; \
   _b = B5[0]; \
   c05 += _b*_a0; \
   _b = B6[0]; \
   c06 += _b*_a0; \
   _b = B7[0]; \
   c07 += _b*_a0; \
   \
   _a0 = A[0]; \
   A += Astride; \
   _b = B0[1]; \
   c00 += _b*_a0; \
   _b = B1[1]; \
   c01 += _b*_a0; \
   _b = B2[1]; \
   c02 += _b*_a0; \
   _b = B3[1]; \
   c03 += _b*_a0; \
   _b = B4[1]; \
   c04 += _b*_a0; \
   _b = B5[1]; \
   c05 += _b*_a0; \
   _b = B6[1]; \
   c06 += _b*_a0; \
   _b = B7[1]; \
   c07 += _b*_a0; \
   \
   _a0 = A[0]; \
   A += Astride; \
   _b = B0[2]; \
   c00 += _b*_a0; \
   _b = B1[2]; \
   c01 += _b*_a0; \
   _b = B2[2]; \
   c02 += _b*_a0; \
   _b = B3[2]; \
   c03 += _b*_a0; \
   _b = B4[2]; \
   c04 += _b*_a0; \
   _b = B5[2]; \
   c05 += _b*_a0; \
   _b = B6[2]; \
   c06 += _b*_a0; \
   _b = B7[2]; \
   c07 += _b*_a0; \
   \
   _a0 = A[0]; \
   A += Astride; \
   _b = B0[3]; \
   c00 += _b*_a0; \
   _b = B1[3]; \
   c01 += _b*_a0; \
   _b = B2[3]; \
   c02 += _b*_a0; \
   _b = B3[3]; \
   c03 += _b*_a0; \
   _b = B4[3]; \
   c04 += _b*_a0; \
   _b = B5[3]; \
   c05 += _b*_a0; \
   _b = B6[3]; \
   c06 += _b*_a0; \
   _b = B7[3]; \
   c07 += _b*_a0; \
}


#define LOAD1x10(c00,c01,c02,c03,c04,c05,c06,c07,c08,c09,C,Cstride) \
{\
   float * _cp = C; \
   c00 = _cp[0]; c01 = _cp[1]; c02 = _cp[2]; c03 = _cp[3]; c04 = _cp[4]; c05 = _cp[5]; c06 = _cp[6]; c07 = _cp[7]; c08 = _cp[8]; c09 = _cp[9]; \
}

#define STORE1x10(c00,c01,c02,c03,c04,c05,c06,c07,c08,c09,C,Cstride) \
{\
   float *_cp = C; \
   _cp[0] = c00; _cp[1] = c01; _cp[2] = c02; _cp[3] = c03; _cp[4] = c04; _cp[5] = c05; _cp[6] = c06; _cp[7] = c07; _cp[8] = c08; _cp[9] = c09; \
}

/* Fixed M,K,N = 1,1,10 matrix matrix multiply. */
#define mul_tmf1x1tmf1x10_mf1x10(c00,c01,c02,c03,c04,c05,c06,c07,c08,c09,A,Astride,B0,B1,B2,B3,B4,B5,B6,B7,B8,B9) \
{ \
   register float _a0; \
   register float _b; \
   \
   \
   _a0 = A[0]; \
   A += Astride; \
   _b = B0[0]; \
   c00 += _b*_a0; \
   _b = B1[0]; \
   c01 += _b*_a0; \
   _b = B2[0]; \
   c02 += _b*_a0; \
   _b = B3[0]; \
   c03 += _b*_a0; \
   _b = B4[0]; \
   c04 += _b*_a0; \
   _b = B5[0]; \
   c05 += _b*_a0; \
   _b = B6[0]; \
   c06 += _b*_a0; \
   _b = B7[0]; \
   c07 += _b*_a0; \
   _b = B8[0]; \
   c08 += _b*_a0; \
   _b = B9[0]; \
   c09 += _b*_a0; \
}


/* Fixed M,K,N = 1,2,10 matrix matrix multiply. */
#define mul_tmf1x2tmf2x10_mf1x10(c00,c01,c02,c03,c04,c05,c06,c07,c08,c09,A,Astride,B0,B1,B2,B3,B4,B5,B6,B7,B8,B9) \
{ \
   register float _a0; \
   register float _b; \
   \
   \
   _a0 = A[0]; \
   A += Astride; \
   _b = B0[0]; \
   c00 += _b*_a0; \
   _b = B1[0]; \
   c01 += _b*_a0; \
   _b = B2[0]; \
   c02 += _b*_a0; \
   _b = B3[0]; \
   c03 += _b*_a0; \
   _b = B4[0]; \
   c04 += _b*_a0; \
   _b = B5[0]; \
   c05 += _b*_a0; \
   _b = B6[0]; \
   c06 += _b*_a0; \
   _b = B7[0]; \
   c07 += _b*_a0; \
   _b = B8[0]; \
   c08 += _b*_a0; \
   _b = B9[0]; \
   c09 += _b*_a0; \
   \
   _a0 = A[0]; \
   A += Astride; \
   _b = B0[1]; \
   c00 += _b*_a0; \
   _b = B1[1]; \
   c01 += _b*_a0; \
   _b = B2[1]; \
   c02 += _b*_a0; \
   _b = B3[1]; \
   c03 += _b*_a0; \
   _b = B4[1]; \
   c04 += _b*_a0; \
   _b = B5[1]; \
   c05 += _b*_a0; \
   _b = B6[1]; \
   c06 += _b*_a0; \
   _b = B7[1]; \
   c07 += _b*_a0; \
   _b = B8[1]; \
   c08 += _b*_a0; \
   _b = B9[1]; \
   c09 += _b*_a0; \
}


/* Fixed M,K,N = 1,4,10 matrix matrix multiply. */
#define mul_tmf1x4tmf4x10_mf1x10(c00,c01,c02,c03,c04,c05,c06,c07,c08,c09,A,Astride,B0,B1,B2,B3,B4,B5,B6,B7,B8,B9) \
{ \
   register float _a0; \
   register float _b; \
   \
   \
   _a0 = A[0]; \
   A += Astride; \
   _b = B0[0]; \
   c00 += _b*_a0; \
   _b = B1[0]; \
   c01 += _b*_a0; \
   _b = B2[0]; \
   c02 += _b*_a0; \
   _b = B3[0]; \
   c03 += _b*_a0; \
   _b = B4[0]; \
   c04 += _b*_a0; \
   _b = B5[0]; \
   c05 += _b*_a0; \
   _b = B6[0]; \
   c06 += _b*_a0; \
   _b = B7[0]; \
   c07 += _b*_a0; \
   _b = B8[0]; \
   c08 += _b*_a0; \
   _b = B9[0]; \
   c09 += _b*_a0; \
   \
   _a0 = A[0]; \
   A += Astride; \
   _b = B0[1]; \
   c00 += _b*_a0; \
   _b = B1[1]; \
   c01 += _b*_a0; \
   _b = B2[1]; \
   c02 += _b*_a0; \
   _b = B3[1]; \
   c03 += _b*_a0; \
   _b = B4[1]; \
   c04 += _b*_a0; \
   _b = B5[1]; \
   c05 += _b*_a0; \
   _b = B6[1]; \
   c06 += _b*_a0; \
   _b = B7[1]; \
   c07 += _b*_a0; \
   _b = B8[1]; \
   c08 += _b*_a0; \
   _b = B9[1]; \
   c09 += _b*_a0; \
   \
   _a0 = A[0]; \
   A += Astride; \
   _b = B0[2]; \
   c00 += _b*_a0; \
   _b = B1[2]; \
   c01 += _b*_a0; \
   _b = B2[2]; \
   c02 += _b*_a0; \
   _b = B3[2]; \
   c03 += _b*_a0; \
   _b = B4[2]; \
   c04 += _b*_a0; \
   _b = B5[2]; \
   c05 += _b*_a0; \
   _b = B6[2]; \
   c06 += _b*_a0; \
   _b = B7[2]; \
   c07 += _b*_a0; \
   _b = B8[2]; \
   c08 += _b*_a0; \
   _b = B9[2]; \
   c09 += _b*_a0; \
   \
   _a0 = A[0]; \
   A += Astride; \
   _b = B0[3]; \
   c00 += _b*_a0; \
   _b = B1[3]; \
   c01 += _b*_a0; \
   _b = B2[3]; \
   c02 += _b*_a0; \
   _b = B3[3]; \
   c03 += _b*_a0; \
   _b = B4[3]; \
   c04 += _b*_a0; \
   _b = B5[3]; \
   c05 += _b*_a0; \
   _b = B6[3]; \
   c06 += _b*_a0; \
   _b = B7[3]; \
   c07 += _b*_a0; \
   _b = B8[3]; \
   c08 += _b*_a0; \
   _b = B9[3]; \
   c09 += _b*_a0; \
}


#define LOAD2x1(c00,c10,C,Cstride) \
{\
   float * _cp = C; \
   c00 = _cp[0]; \
   _cp += Cstride; \
   c10 = _cp[0]; \
}

#define STORE2x1(c00,c10,C,Cstride) \
{\
   float *_cp = C; \
   _cp[0] = c00; \
   _cp += Cstride; \
   _cp[0] = c10; \
}

/* Fixed M,K,N = 2,1,1 matrix matrix multiply. */
#define mul_tmf2x1tmf1x1_mf2x1(c00,c10,A,Astride,B0) \
{ \
   register float _a0,_a1; \
   register float _b; \
   \
   \
   _a0 = A[0]; _a1 = A[1]; \
   A += Astride; \
   _b = B0[0]; \
   c00 += _b*_a0; c10 += _b*_a1; \
}


/* Fixed M,K,N = 2,2,1 matrix matrix multiply. */
#define mul_tmf2x2tmf2x1_mf2x1(c00,c10,A,Astride,B0) \
{ \
   register float _a0,_a1; \
   register float _b; \
   \
   \
   _a0 = A[0]; _a1 = A[1]; \
   A += Astride; \
   _b = B0[0]; \
   c00 += _b*_a0; c10 += _b*_a1; \
   \
   _a0 = A[0]; _a1 = A[1]; \
   A += Astride; \
   _b = B0[1]; \
   c00 += _b*_a0; c10 += _b*_a1; \
}


/* Fixed M,K,N = 2,4,1 matrix matrix multiply. */
#define mul_tmf2x4tmf4x1_mf2x1(c00,c10,A,Astride,B0) \
{ \
   register float _a0,_a1; \
   register float _b; \
   \
   \
   _a0 = A[0]; _a1 = A[1]; \
   A += Astride; \
   _b = B0[0]; \
   c00 += _b*_a0; c10 += _b*_a1; \
   \
   _a0 = A[0]; _a1 = A[1]; \
   A += Astride; \
   _b = B0[1]; \
   c00 += _b*_a0; c10 += _b*_a1; \
   \
   _a0 = A[0]; _a1 = A[1]; \
   A += Astride; \
   _b = B0[2]; \
   c00 += _b*_a0; c10 += _b*_a1; \
   \
   _a0 = A[0]; _a1 = A[1]; \
   A += Astride; \
   _b = B0[3]; \
   c00 += _b*_a0; c10 += _b*_a1; \
}


#define LOAD2x2(c00,c01,c10,c11,C,Cstride) \
{\
   float * _cp = C; \
   c00 = _cp[0]; c01 = _cp[1]; \
   _cp += Cstride; \
   c10 = _cp[0]; c11 = _cp[1]; \
}

#define STORE2x2(c00,c01,c10,c11,C,Cstride) \
{\
   float *_cp = C; \
   _cp[0] = c00; _cp[1] = c01; \
   _cp += Cstride; \
   _cp[0] = c10; _cp[1] = c11; \
}

/* Fixed M,K,N = 2,1,2 matrix matrix multiply. */
#define mul_tmf2x1tmf1x2_mf2x2(c00,c01,c10,c11,A,Astride,B0,B1) \
{ \
   register float _a0,_a1; \
   register float _b; \
   \
   \
   _a0 = A[0]; _a1 = A[1]; \
   A += Astride; \
   _b = B0[0]; \
   c00 += _b*_a0; c10 += _b*_a1; \
   _b = B1[0]; \
   c01 += _b*_a0; c11 += _b*_a1; \
}


/* Fixed M,K,N = 2,2,2 matrix matrix multiply. */
#define mul_tmf2x2tmf2x2_mf2x2(c00,c01,c10,c11,A,Astride,B0,B1) \
{ \
   register float _a0,_a1; \
   register float _b; \
   \
   \
   _a0 = A[0]; _a1 = A[1]; \
   A += Astride; \
   _b = B0[0]; \
   c00 += _b*_a0; c10 += _b*_a1; \
   _b = B1[0]; \
   c01 += _b*_a0; c11 += _b*_a1; \
   \
   _a0 = A[0]; _a1 = A[1]; \
   A += Astride; \
   _b = B0[1]; \
   c00 += _b*_a0; c10 += _b*_a1; \
   _b = B1[1]; \
   c01 += _b*_a0; c11 += _b*_a1; \
}


/* Fixed M,K,N = 2,4,2 matrix matrix multiply. */
#define mul_tmf2x4tmf4x2_mf2x2(c00,c01,c10,c11,A,Astride,B0,B1) \
{ \
   register float _a0,_a1; \
   register float _b; \
   \
   \
   _a0 = A[0]; _a1 = A[1]; \
   A += Astride; \
   _b = B0[0]; \
   c00 += _b*_a0; c10 += _b*_a1; \
   _b = B1[0]; \
   c01 += _b*_a0; c11 += _b*_a1; \
   \
   _a0 = A[0]; _a1 = A[1]; \
   A += Astride; \
   _b = B0[1]; \
   c00 += _b*_a0; c10 += _b*_a1; \
   _b = B1[1]; \
   c01 += _b*_a0; c11 += _b*_a1; \
   \
   _a0 = A[0]; _a1 = A[1]; \
   A += Astride; \
   _b = B0[2]; \
   c00 += _b*_a0; c10 += _b*_a1; \
   _b = B1[2]; \
   c01 += _b*_a0; c11 += _b*_a1; \
   \
   _a0 = A[0]; _a1 = A[1]; \
   A += Astride; \
   _b = B0[3]; \
   c00 += _b*_a0; c10 += _b*_a1; \
   _b = B1[3]; \
   c01 += _b*_a0; c11 += _b*_a1; \
}


#define LOAD2x4(c00,c01,c02,c03,c10,c11,c12,c13,C,Cstride) \
{\
   float * _cp = C; \
   c00 = _cp[0]; c01 = _cp[1]; c02 = _cp[2]; c03 = _cp[3]; \
   _cp += Cstride; \
   c10 = _cp[0]; c11 = _cp[1]; c12 = _cp[2]; c13 = _cp[3]; \
}

#define STORE2x4(c00,c01,c02,c03,c10,c11,c12,c13,C,Cstride) \
{\
   float *_cp = C; \
   _cp[0] = c00; _cp[1] = c01; _cp[2] = c02; _cp[3] = c03; \
   _cp += Cstride; \
   _cp[0] = c10; _cp[1] = c11; _cp[2] = c12; _cp[3] = c13; \
}

/* Fixed M,K,N = 2,1,4 matrix matrix multiply. */
#define mul_tmf2x1tmf1x4_mf2x4(c00,c01,c02,c03,c10,c11,c12,c13,A,Astride,B0,B1,B2,B3) \
{ \
   register float _a0,_a1; \
   register float _b; \
   \
   \
   _a0 = A[0]; _a1 = A[1]; \
   A += Astride; \
   _b = B0[0]; \
   c00 += _b*_a0; c10 += _b*_a1; \
   _b = B1[0]; \
   c01 += _b*_a0; c11 += _b*_a1; \
   _b = B2[0]; \
   c02 += _b*_a0; c12 += _b*_a1; \
   _b = B3[0]; \
   c03 += _b*_a0; c13 += _b*_a1; \
}


/* Fixed M,K,N = 2,2,4 matrix matrix multiply. */
#define mul_tmf2x2tmf2x4_mf2x4(c00,c01,c02,c03,c10,c11,c12,c13,A,Astride,B0,B1,B2,B3) \
{ \
   register float _a0,_a1; \
   register float _b; \
   \
   \
   _a0 = A[0]; _a1 = A[1]; \
   A += Astride; \
   _b = B0[0]; \
   c00 += _b*_a0; c10 += _b*_a1; \
   _b = B1[0]; \
   c01 += _b*_a0; c11 += _b*_a1; \
   _b = B2[0]; \
   c02 += _b*_a0; c12 += _b*_a1; \
   _b = B3[0]; \
   c03 += _b*_a0; c13 += _b*_a1; \
   \
   _a0 = A[0]; _a1 = A[1]; \
   A += Astride; \
   _b = B0[1]; \
   c00 += _b*_a0; c10 += _b*_a1; \
   _b = B1[1]; \
   c01 += _b*_a0; c11 += _b*_a1; \
   _b = B2[1]; \
   c02 += _b*_a0; c12 += _b*_a1; \
   _b = B3[1]; \
   c03 += _b*_a0; c13 += _b*_a1; \
}


/* Fixed M,K,N = 2,4,4 matrix matrix multiply. */
#define mul_tmf2x4tmf4x4_mf2x4(c00,c01,c02,c03,c10,c11,c12,c13,A,Astride,B0,B1,B2,B3) \
{ \
   register float _a0,_a1; \
   register float _b; \
   \
   \
   _a0 = A[0]; _a1 = A[1]; \
   A += Astride; \
   _b = B0[0]; \
   c00 += _b*_a0; c10 += _b*_a1; \
   _b = B1[0]; \
   c01 += _b*_a0; c11 += _b*_a1; \
   _b = B2[0]; \
   c02 += _b*_a0; c12 += _b*_a1; \
   _b = B3[0]; \
   c03 += _b*_a0; c13 += _b*_a1; \
   \
   _a0 = A[0]; _a1 = A[1]; \
   A += Astride; \
   _b = B0[1]; \
   c00 += _b*_a0; c10 += _b*_a1; \
   _b = B1[1]; \
   c01 += _b*_a0; c11 += _b*_a1; \
   _b = B2[1]; \
   c02 += _b*_a0; c12 += _b*_a1; \
   _b = B3[1]; \
   c03 += _b*_a0; c13 += _b*_a1; \
   \
   _a0 = A[0]; _a1 = A[1]; \
   A += Astride; \
   _b = B0[2]; \
   c00 += _b*_a0; c10 += _b*_a1; \
   _b = B1[2]; \
   c01 += _b*_a0; c11 += _b*_a1; \
   _b = B2[2]; \
   c02 += _b*_a0; c12 += _b*_a1; \
   _b = B3[2]; \
   c03 += _b*_a0; c13 += _b*_a1; \
   \
   _a0 = A[0]; _a1 = A[1]; \
   A += Astride; \
   _b = B0[3]; \
   c00 += _b*_a0; c10 += _b*_a1; \
   _b = B1[3]; \
   c01 += _b*_a0; c11 += _b*_a1; \
   _b = B2[3]; \
   c02 += _b*_a0; c12 += _b*_a1; \
   _b = B3[3]; \
   c03 += _b*_a0; c13 += _b*_a1; \
}


#define LOAD2x8(c00,c01,c02,c03,c04,c05,c06,c07,c10,c11,c12,c13,c14,c15,c16,c17,C,Cstride) \
{\
   float * _cp = C; \
   c00 = _cp[0]; c01 = _cp[1]; c02 = _cp[2]; c03 = _cp[3]; c04 = _cp[4]; c05 = _cp[5]; c06 = _cp[6]; c07 = _cp[7]; \
   _cp += Cstride; \
   c10 = _cp[0]; c11 = _cp[1]; c12 = _cp[2]; c13 = _cp[3]; c14 = _cp[4]; c15 = _cp[5]; c16 = _cp[6]; c17 = _cp[7]; \
}

#define STORE2x8(c00,c01,c02,c03,c04,c05,c06,c07,c10,c11,c12,c13,c14,c15,c16,c17,C,Cstride) \
{\
   float *_cp = C; \
   _cp[0] = c00; _cp[1] = c01; _cp[2] = c02; _cp[3] = c03; _cp[4] = c04; _cp[5] = c05; _cp[6] = c06; _cp[7] = c07; \
   _cp += Cstride; \
   _cp[0] = c10; _cp[1] = c11; _cp[2] = c12; _cp[3] = c13; _cp[4] = c14; _cp[5] = c15; _cp[6] = c16; _cp[7] = c17; \
}

/* Fixed M,K,N = 2,1,8 matrix matrix multiply. */
#define mul_tmf2x1tmf1x8_mf2x8(c00,c01,c02,c03,c04,c05,c06,c07,c10,c11,c12,c13,c14,c15,c16,c17,A,Astride,B0,B1,B2,B3,B4,B5,B6,B7) \
{ \
   register float _a0,_a1; \
   register float _b; \
   \
   \
   _a0 = A[0]; _a1 = A[1]; \
   A += Astride; \
   _b = B0[0]; \
   c00 += _b*_a0; c10 += _b*_a1; \
   _b = B1[0]; \
   c01 += _b*_a0; c11 += _b*_a1; \
   _b = B2[0]; \
   c02 += _b*_a0; c12 += _b*_a1; \
   _b = B3[0]; \
   c03 += _b*_a0; c13 += _b*_a1; \
   _b = B4[0]; \
   c04 += _b*_a0; c14 += _b*_a1; \
   _b = B5[0]; \
   c05 += _b*_a0; c15 += _b*_a1; \
   _b = B6[0]; \
   c06 += _b*_a0; c16 += _b*_a1; \
   _b = B7[0]; \
   c07 += _b*_a0; c17 += _b*_a1; \
}


/* Fixed M,K,N = 2,2,8 matrix matrix multiply. */
#define mul_tmf2x2tmf2x8_mf2x8(c00,c01,c02,c03,c04,c05,c06,c07,c10,c11,c12,c13,c14,c15,c16,c17,A,Astride,B0,B1,B2,B3,B4,B5,B6,B7) \
{ \
   register float _a0,_a1; \
   register float _b; \
   \
   \
   _a0 = A[0]; _a1 = A[1]; \
   A += Astride; \
   _b = B0[0]; \
   c00 += _b*_a0; c10 += _b*_a1; \
   _b = B1[0]; \
   c01 += _b*_a0; c11 += _b*_a1; \
   _b = B2[0]; \
   c02 += _b*_a0; c12 += _b*_a1; \
   _b = B3[0]; \
   c03 += _b*_a0; c13 += _b*_a1; \
   _b = B4[0]; \
   c04 += _b*_a0; c14 += _b*_a1; \
   _b = B5[0]; \
   c05 += _b*_a0; c15 += _b*_a1; \
   _b = B6[0]; \
   c06 += _b*_a0; c16 += _b*_a1; \
   _b = B7[0]; \
   c07 += _b*_a0; c17 += _b*_a1; \
   \
   _a0 = A[0]; _a1 = A[1]; \
   A += Astride; \
   _b = B0[1]; \
   c00 += _b*_a0; c10 += _b*_a1; \
   _b = B1[1]; \
   c01 += _b*_a0; c11 += _b*_a1; \
   _b = B2[1]; \
   c02 += _b*_a0; c12 += _b*_a1; \
   _b = B3[1]; \
   c03 += _b*_a0; c13 += _b*_a1; \
   _b = B4[1]; \
   c04 += _b*_a0; c14 += _b*_a1; \
   _b = B5[1]; \
   c05 += _b*_a0; c15 += _b*_a1; \
   _b = B6[1]; \
   c06 += _b*_a0; c16 += _b*_a1; \
   _b = B7[1]; \
   c07 += _b*_a0; c17 += _b*_a1; \
}


/* Fixed M,K,N = 2,4,8 matrix matrix multiply. */
#define mul_tmf2x4tmf4x8_mf2x8(c00,c01,c02,c03,c04,c05,c06,c07,c10,c11,c12,c13,c14,c15,c16,c17,A,Astride,B0,B1,B2,B3,B4,B5,B6,B7) \
{ \
   register float _a0,_a1; \
   register float _b; \
   \
   \
   _a0 = A[0]; _a1 = A[1]; \
   A += Astride; \
   _b = B0[0]; \
   c00 += _b*_a0; c10 += _b*_a1; \
   _b = B1[0]; \
   c01 += _b*_a0; c11 += _b*_a1; \
   _b = B2[0]; \
   c02 += _b*_a0; c12 += _b*_a1; \
   _b = B3[0]; \
   c03 += _b*_a0; c13 += _b*_a1; \
   _b = B4[0]; \
   c04 += _b*_a0; c14 += _b*_a1; \
   _b = B5[0]; \
   c05 += _b*_a0; c15 += _b*_a1; \
   _b = B6[0]; \
   c06 += _b*_a0; c16 += _b*_a1; \
   _b = B7[0]; \
   c07 += _b*_a0; c17 += _b*_a1; \
   \
   _a0 = A[0]; _a1 = A[1]; \
   A += Astride; \
   _b = B0[1]; \
   c00 += _b*_a0; c10 += _b*_a1; \
   _b = B1[1]; \
   c01 += _b*_a0; c11 += _b*_a1; \
   _b = B2[1]; \
   c02 += _b*_a0; c12 += _b*_a1; \
   _b = B3[1]; \
   c03 += _b*_a0; c13 += _b*_a1; \
   _b = B4[1]; \
   c04 += _b*_a0; c14 += _b*_a1; \
   _b = B5[1]; \
   c05 += _b*_a0; c15 += _b*_a1; \
   _b = B6[1]; \
   c06 += _b*_a0; c16 += _b*_a1; \
   _b = B7[1]; \
   c07 += _b*_a0; c17 += _b*_a1; \
   \
   _a0 = A[0]; _a1 = A[1]; \
   A += Astride; \
   _b = B0[2]; \
   c00 += _b*_a0; c10 += _b*_a1; \
   _b = B1[2]; \
   c01 += _b*_a0; c11 += _b*_a1; \
   _b = B2[2]; \
   c02 += _b*_a0; c12 += _b*_a1; \
   _b = B3[2]; \
   c03 += _b*_a0; c13 += _b*_a1; \
   _b = B4[2]; \
   c04 += _b*_a0; c14 += _b*_a1; \
   _b = B5[2]; \
   c05 += _b*_a0; c15 += _b*_a1; \
   _b = B6[2]; \
   c06 += _b*_a0; c16 += _b*_a1; \
   _b = B7[2]; \
   c07 += _b*_a0; c17 += _b*_a1; \
   \
   _a0 = A[0]; _a1 = A[1]; \
   A += Astride; \
   _b = B0[3]; \
   c00 += _b*_a0; c10 += _b*_a1; \
   _b = B1[3]; \
   c01 += _b*_a0; c11 += _b*_a1; \
   _b = B2[3]; \
   c02 += _b*_a0; c12 += _b*_a1; \
   _b = B3[3]; \
   c03 += _b*_a0; c13 += _b*_a1; \
   _b = B4[3]; \
   c04 += _b*_a0; c14 += _b*_a1; \
   _b = B5[3]; \
   c05 += _b*_a0; c15 += _b*_a1; \
   _b = B6[3]; \
   c06 += _b*_a0; c16 += _b*_a1; \
   _b = B7[3]; \
   c07 += _b*_a0; c17 += _b*_a1; \
}


#define LOAD2x10(c00,c01,c02,c03,c04,c05,c06,c07,c08,c09,c10,c11,c12,c13,c14,c15,c16,c17,c18,c19,C,Cstride) \
{\
   float * _cp = C; \
   c00 = _cp[0]; c01 = _cp[1]; c02 = _cp[2]; c03 = _cp[3]; c04 = _cp[4]; c05 = _cp[5]; c06 = _cp[6]; c07 = _cp[7]; c08 = _cp[8]; c09 = _cp[9]; \
   _cp += Cstride; \
   c10 = _cp[0]; c11 = _cp[1]; c12 = _cp[2]; c13 = _cp[3]; c14 = _cp[4]; c15 = _cp[5]; c16 = _cp[6]; c17 = _cp[7]; c18 = _cp[8]; c19 = _cp[9]; \
}

#define STORE2x10(c00,c01,c02,c03,c04,c05,c06,c07,c08,c09,c10,c11,c12,c13,c14,c15,c16,c17,c18,c19,C,Cstride) \
{\
   float *_cp = C; \
   _cp[0] = c00; _cp[1] = c01; _cp[2] = c02; _cp[3] = c03; _cp[4] = c04; _cp[5] = c05; _cp[6] = c06; _cp[7] = c07; _cp[8] = c08; _cp[9] = c09; \
   _cp += Cstride; \
   _cp[0] = c10; _cp[1] = c11; _cp[2] = c12; _cp[3] = c13; _cp[4] = c14; _cp[5] = c15; _cp[6] = c16; _cp[7] = c17; _cp[8] = c18; _cp[9] = c19; \
}

/* Fixed M,K,N = 2,1,10 matrix matrix multiply. */
#define mul_tmf2x1tmf1x10_mf2x10(c00,c01,c02,c03,c04,c05,c06,c07,c08,c09,c10,c11,c12,c13,c14,c15,c16,c17,c18,c19,A,Astride,B0,B1,B2,B3,B4,B5,B6,B7,B8,B9) \
{ \
   register float _a0,_a1; \
   register float _b; \
   \
   \
   _a0 = A[0]; _a1 = A[1]; \
   A += Astride; \
   _b = B0[0]; \
   c00 += _b*_a0; c10 += _b*_a1; \
   _b = B1[0]; \
   c01 += _b*_a0; c11 += _b*_a1; \
   _b = B2[0]; \
   c02 += _b*_a0; c12 += _b*_a1; \
   _b = B3[0]; \
   c03 += _b*_a0; c13 += _b*_a1; \
   _b = B4[0]; \
   c04 += _b*_a0; c14 += _b*_a1; \
   _b = B5[0]; \
   c05 += _b*_a0; c15 += _b*_a1; \
   _b = B6[0]; \
   c06 += _b*_a0; c16 += _b*_a1; \
   _b = B7[0]; \
   c07 += _b*_a0; c17 += _b*_a1; \
   _b = B8[0]; \
   c08 += _b*_a0; c18 += _b*_a1; \
   _b = B9[0]; \
   c09 += _b*_a0; c19 += _b*_a1; \
}


/* Fixed M,K,N = 2,2,10 matrix matrix multiply. */
#define mul_tmf2x2tmf2x10_mf2x10(c00,c01,c02,c03,c04,c05,c06,c07,c08,c09,c10,c11,c12,c13,c14,c15,c16,c17,c18,c19,A,Astride,B0,B1,B2,B3,B4,B5,B6,B7,B8,B9) \
{ \
   register float _a0,_a1; \
   register float _b; \
   \
   \
   _a0 = A[0]; _a1 = A[1]; \
   A += Astride; \
   _b = B0[0]; \
   c00 += _b*_a0; c10 += _b*_a1; \
   _b = B1[0]; \
   c01 += _b*_a0; c11 += _b*_a1; \
   _b = B2[0]; \
   c02 += _b*_a0; c12 += _b*_a1; \
   _b = B3[0]; \
   c03 += _b*_a0; c13 += _b*_a1; \
   _b = B4[0]; \
   c04 += _b*_a0; c14 += _b*_a1; \
   _b = B5[0]; \
   c05 += _b*_a0; c15 += _b*_a1; \
   _b = B6[0]; \
   c06 += _b*_a0; c16 += _b*_a1; \
   _b = B7[0]; \
   c07 += _b*_a0; c17 += _b*_a1; \
   _b = B8[0]; \
   c08 += _b*_a0; c18 += _b*_a1; \
   _b = B9[0]; \
   c09 += _b*_a0; c19 += _b*_a1; \
   \
   _a0 = A[0]; _a1 = A[1]; \
   A += Astride; \
   _b = B0[1]; \
   c00 += _b*_a0; c10 += _b*_a1; \
   _b = B1[1]; \
   c01 += _b*_a0; c11 += _b*_a1; \
   _b = B2[1]; \
   c02 += _b*_a0; c12 += _b*_a1; \
   _b = B3[1]; \
   c03 += _b*_a0; c13 += _b*_a1; \
   _b = B4[1]; \
   c04 += _b*_a0; c14 += _b*_a1; \
   _b = B5[1]; \
   c05 += _b*_a0; c15 += _b*_a1; \
   _b = B6[1]; \
   c06 += _b*_a0; c16 += _b*_a1; \
   _b = B7[1]; \
   c07 += _b*_a0; c17 += _b*_a1; \
   _b = B8[1]; \
   c08 += _b*_a0; c18 += _b*_a1; \
   _b = B9[1]; \
   c09 += _b*_a0; c19 += _b*_a1; \
}


/* Fixed M,K,N = 2,4,10 matrix matrix multiply. */
#define mul_tmf2x4tmf4x10_mf2x10(c00,c01,c02,c03,c04,c05,c06,c07,c08,c09,c10,c11,c12,c13,c14,c15,c16,c17,c18,c19,A,Astride,B0,B1,B2,B3,B4,B5,B6,B7,B8,B9) \
{ \
   register float _a0,_a1; \
   register float _b; \
   \
   \
   _a0 = A[0]; _a1 = A[1]; \
   A += Astride; \
   _b = B0[0]; \
   c00 += _b*_a0; c10 += _b*_a1; \
   _b = B1[0]; \
   c01 += _b*_a0; c11 += _b*_a1; \
   _b = B2[0]; \
   c02 += _b*_a0; c12 += _b*_a1; \
   _b = B3[0]; \
   c03 += _b*_a0; c13 += _b*_a1; \
   _b = B4[0]; \
   c04 += _b*_a0; c14 += _b*_a1; \
   _b = B5[0]; \
   c05 += _b*_a0; c15 += _b*_a1; \
   _b = B6[0]; \
   c06 += _b*_a0; c16 += _b*_a1; \
   _b = B7[0]; \
   c07 += _b*_a0; c17 += _b*_a1; \
   _b = B8[0]; \
   c08 += _b*_a0; c18 += _b*_a1; \
   _b = B9[0]; \
   c09 += _b*_a0; c19 += _b*_a1; \
   \
   _a0 = A[0]; _a1 = A[1]; \
   A += Astride; \
   _b = B0[1]; \
   c00 += _b*_a0; c10 += _b*_a1; \
   _b = B1[1]; \
   c01 += _b*_a0; c11 += _b*_a1; \
   _b = B2[1]; \
   c02 += _b*_a0; c12 += _b*_a1; \
   _b = B3[1]; \
   c03 += _b*_a0; c13 += _b*_a1; \
   _b = B4[1]; \
   c04 += _b*_a0; c14 += _b*_a1; \
   _b = B5[1]; \
   c05 += _b*_a0; c15 += _b*_a1; \
   _b = B6[1]; \
   c06 += _b*_a0; c16 += _b*_a1; \
   _b = B7[1]; \
   c07 += _b*_a0; c17 += _b*_a1; \
   _b = B8[1]; \
   c08 += _b*_a0; c18 += _b*_a1; \
   _b = B9[1]; \
   c09 += _b*_a0; c19 += _b*_a1; \
   \
   _a0 = A[0]; _a1 = A[1]; \
   A += Astride; \
   _b = B0[2]; \
   c00 += _b*_a0; c10 += _b*_a1; \
   _b = B1[2]; \
   c01 += _b*_a0; c11 += _b*_a1; \
   _b = B2[2]; \
   c02 += _b*_a0; c12 += _b*_a1; \
   _b = B3[2]; \
   c03 += _b*_a0; c13 += _b*_a1; \
   _b = B4[2]; \
   c04 += _b*_a0; c14 += _b*_a1; \
   _b = B5[2]; \
   c05 += _b*_a0; c15 += _b*_a1; \
   _b = B6[2]; \
   c06 += _b*_a0; c16 += _b*_a1; \
   _b = B7[2]; \
   c07 += _b*_a0; c17 += _b*_a1; \
   _b = B8[2]; \
   c08 += _b*_a0; c18 += _b*_a1; \
   _b = B9[2]; \
   c09 += _b*_a0; c19 += _b*_a1; \
   \
   _a0 = A[0]; _a1 = A[1]; \
   A += Astride; \
   _b = B0[3]; \
   c00 += _b*_a0; c10 += _b*_a1; \
   _b = B1[3]; \
   c01 += _b*_a0; c11 += _b*_a1; \
   _b = B2[3]; \
   c02 += _b*_a0; c12 += _b*_a1; \
   _b = B3[3]; \
   c03 += _b*_a0; c13 += _b*_a1; \
   _b = B4[3]; \
   c04 += _b*_a0; c14 += _b*_a1; \
   _b = B5[3]; \
   c05 += _b*_a0; c15 += _b*_a1; \
   _b = B6[3]; \
   c06 += _b*_a0; c16 += _b*_a1; \
   _b = B7[3]; \
   c07 += _b*_a0; c17 += _b*_a1; \
   _b = B8[3]; \
   c08 += _b*_a0; c18 += _b*_a1; \
   _b = B9[3]; \
   c09 += _b*_a0; c19 += _b*_a1; \
}


/* Fixed M,N = 52,50, Arbitrary K L1-blocked matrix matrix multiply. */
void
_multtacc_mfmf_mf_l1_arb_k(int K, const float *const A, const float *const B, float *const C, const int Astride, const int Bstride, const int Cstride)
{
   const float *a0,*b0;
   float *c0;
   const float *ap0;
   const float *bp0_0,*bp0_1,*bp0_2,*bp0_3,*bp0_4,*bp0_5,*bp0_6,*bp0_7,*bp0_8,*bp0_9;
   float *cp0;
   const int B_sbs_stride = Bstride*10;
   const int C_sbs_stride = Cstride*2;
   const int k_marg_el = K & 3;
   const int k_norm = (K - k_marg_el)*Astride;
   float *const c0_endp = C+52*Cstride;
   register float c00,c01,c02,c03,c04,c05,c06,c07,c08,c09,c10,c11,c12,c13,c14,c15,c16,c17,c18,c19;
   for (c0=C,a0=A; c0!= c0_endp; c0+=C_sbs_stride,a0+=2) {
      const float* const ap0_endp = a0 + k_norm;
      float* const cp0_endp = c0 + 50;
      for (b0=B,cp0=c0; cp0!=cp0_endp; b0+=B_sbs_stride,cp0+=10) {
         ap0=a0;
         bp0_0 = b0;
         bp0_1 = bp0_0 + Bstride;
         bp0_2 = bp0_1 + Bstride;
         bp0_3 = bp0_2 + Bstride;
         bp0_4 = bp0_3 + Bstride;
         bp0_5 = bp0_4 + Bstride;
         bp0_6 = bp0_5 + Bstride;
         bp0_7 = bp0_6 + Bstride;
         bp0_8 = bp0_7 + Bstride;
         bp0_9 = bp0_8 + Bstride;
         LOAD2x10(c00,c01,c02,c03,c04,c05,c06,c07,c08,c09,c10,c11,c12,c13,c14,c15,c16,c17,c18,c19,cp0,Cstride);
         for (; ap0!=ap0_endp; bp0_0+=4,bp0_1+=4,bp0_2+=4,bp0_3+=4,bp0_4+=4,bp0_5+=4,bp0_6+=4,bp0_7+=4,bp0_8+=4,bp0_9+=4) {
            mul_tmf2x4tmf4x10_mf2x10(c00,c01,c02,c03,c04,c05,c06,c07,c08,c09,c10,c11,c12,c13,c14,c15,c16,c17,c18,c19,ap0,Astride,bp0_0,bp0_1,bp0_2,bp0_3,bp0_4,bp0_5,bp0_6,bp0_7,bp0_8,bp0_9);
         }
         if (k_marg_el & 0x2) {
            mul_tmf2x2tmf2x10_mf2x10(c00,c01,c02,c03,c04,c05,c06,c07,c08,c09,c10,c11,c12,c13,c14,c15,c16,c17,c18,c19,ap0,Astride,bp0_0,bp0_1,bp0_2,bp0_3,bp0_4,bp0_5,bp0_6,bp0_7,bp0_8,bp0_9);
            bp0_0+=2;bp0_1+=2;bp0_2+=2;bp0_3+=2;bp0_4+=2;bp0_5+=2;bp0_6+=2;bp0_7+=2;bp0_8+=2;bp0_9+=2;
         }
         if (k_marg_el & 0x1) {
            mul_tmf2x1tmf1x10_mf2x10(c00,c01,c02,c03,c04,c05,c06,c07,c08,c09,c10,c11,c12,c13,c14,c15,c16,c17,c18,c19,ap0,Astride,bp0_0,bp0_1,bp0_2,bp0_3,bp0_4,bp0_5,bp0_6,bp0_7,bp0_8,bp0_9);
         }
         STORE2x10(c00,c01,c02,c03,c04,c05,c06,c07,c08,c09,c10,c11,c12,c13,c14,c15,c16,c17,c18,c19,cp0,Cstride);
      }
   }
}

/* Arbitrary M,K,N L1-blocked matrix matrix multiply. */
void
_multtacc_mfmf_mf_l1_arb_all(const int M, const int K, const int N, const float *const A, const float *const B, float *const C, const int Astride, const int Bstride, const int Cstride)
{
   const float *a0,*b0;
   float *c0;
   const float *ap0;
   const float *bp0_0,*bp0_1,*bp0_2,*bp0_3,*bp0_4,*bp0_5,*bp0_6,*bp0_7,*bp0_8,*bp0_9;
   float *cp0;
   const int B_sbs_stride = Bstride*10;
   const int C_sbs_stride = Cstride*2;
   const int k_marg_el = K & 3;
   const int k_norm = (K - k_marg_el)*Astride;
   const int m_marg_el = M & 1;
   const int m_norm = M - m_marg_el;
   const int n_marg_el = N % 10;
   const int n_norm = N - n_marg_el;
   float *const c0_endp = C+m_norm*Cstride;
   register float c00,c01,c02,c03,c04,c05,c06,c07,c08,c09,c10,c11,c12,c13,c14,c15,c16,c17,c18,c19;
   for (c0=C,a0=A; c0!= c0_endp; c0+=C_sbs_stride,a0+=2) {
      const float* const ap0_endp = a0 + k_norm;
      float* const cp0_endp = c0 + n_norm;
      for (b0=B,cp0=c0; cp0!=cp0_endp; b0+=B_sbs_stride,cp0+=10) {
         ap0=a0;
         bp0_0 = b0;
         bp0_1 = bp0_0 + Bstride;
         bp0_2 = bp0_1 + Bstride;
         bp0_3 = bp0_2 + Bstride;
         bp0_4 = bp0_3 + Bstride;
         bp0_5 = bp0_4 + Bstride;
         bp0_6 = bp0_5 + Bstride;
         bp0_7 = bp0_6 + Bstride;
         bp0_8 = bp0_7 + Bstride;
         bp0_9 = bp0_8 + Bstride;
         LOAD2x10(c00,c01,c02,c03,c04,c05,c06,c07,c08,c09,c10,c11,c12,c13,c14,c15,c16,c17,c18,c19,cp0,Cstride);
         for (; ap0!=ap0_endp; bp0_0+=4,bp0_1+=4,bp0_2+=4,bp0_3+=4,bp0_4+=4,bp0_5+=4,bp0_6+=4,bp0_7+=4,bp0_8+=4,bp0_9+=4) {
            mul_tmf2x4tmf4x10_mf2x10(c00,c01,c02,c03,c04,c05,c06,c07,c08,c09,c10,c11,c12,c13,c14,c15,c16,c17,c18,c19,ap0,Astride,bp0_0,bp0_1,bp0_2,bp0_3,bp0_4,bp0_5,bp0_6,bp0_7,bp0_8,bp0_9);
         }
         if (k_marg_el & 0x2) {
            mul_tmf2x2tmf2x10_mf2x10(c00,c01,c02,c03,c04,c05,c06,c07,c08,c09,c10,c11,c12,c13,c14,c15,c16,c17,c18,c19,ap0,Astride,bp0_0,bp0_1,bp0_2,bp0_3,bp0_4,bp0_5,bp0_6,bp0_7,bp0_8,bp0_9);
            bp0_0+=2;bp0_1+=2;bp0_2+=2;bp0_3+=2;bp0_4+=2;bp0_5+=2;bp0_6+=2;bp0_7+=2;bp0_8+=2;bp0_9+=2;
         }
         if (k_marg_el & 0x1) {
            mul_tmf2x1tmf1x10_mf2x10(c00,c01,c02,c03,c04,c05,c06,c07,c08,c09,c10,c11,c12,c13,c14,c15,c16,c17,c18,c19,ap0,Astride,bp0_0,bp0_1,bp0_2,bp0_3,bp0_4,bp0_5,bp0_6,bp0_7,bp0_8,bp0_9);
         }
         STORE2x10(c00,c01,c02,c03,c04,c05,c06,c07,c08,c09,c10,c11,c12,c13,c14,c15,c16,c17,c18,c19,cp0,Cstride);
      }
   }
   for (c0=C,a0=A; c0!= c0_endp; c0+=C_sbs_stride,a0+=2) {
      const float* const ap0_endp = a0 + k_norm;
      b0 = B+n_norm*Bstride;
      cp0 = c0+n_norm;
      if (n_marg_el & 0x8) {
         ap0=a0;
         bp0_0 = b0;
         bp0_1 = bp0_0 + Bstride;
         bp0_2 = bp0_1 + Bstride;
         bp0_3 = bp0_2 + Bstride;
         bp0_4 = bp0_3 + Bstride;
         bp0_5 = bp0_4 + Bstride;
         bp0_6 = bp0_5 + Bstride;
         bp0_7 = bp0_6 + Bstride;
         LOAD2x8(c00,c01,c02,c03,c04,c05,c06,c07,c10,c11,c12,c13,c14,c15,c16,c17,cp0,Cstride);
         for (; ap0!=ap0_endp; bp0_0+=4,bp0_1+=4,bp0_2+=4,bp0_3+=4,bp0_4+=4,bp0_5+=4,bp0_6+=4,bp0_7+=4) {
            mul_tmf2x4tmf4x8_mf2x8(c00,c01,c02,c03,c04,c05,c06,c07,c10,c11,c12,c13,c14,c15,c16,c17,ap0,Astride,bp0_0,bp0_1,bp0_2,bp0_3,bp0_4,bp0_5,bp0_6,bp0_7);
         }
         if (k_marg_el & 0x2) {
            mul_tmf2x2tmf2x8_mf2x8(c00,c01,c02,c03,c04,c05,c06,c07,c10,c11,c12,c13,c14,c15,c16,c17,ap0,Astride,bp0_0,bp0_1,bp0_2,bp0_3,bp0_4,bp0_5,bp0_6,bp0_7);
            bp0_0+=2;bp0_1+=2;bp0_2+=2;bp0_3+=2;bp0_4+=2;bp0_5+=2;bp0_6+=2;bp0_7+=2;
         }
         if (k_marg_el & 0x1) {
            mul_tmf2x1tmf1x8_mf2x8(c00,c01,c02,c03,c04,c05,c06,c07,c10,c11,c12,c13,c14,c15,c16,c17,ap0,Astride,bp0_0,bp0_1,bp0_2,bp0_3,bp0_4,bp0_5,bp0_6,bp0_7);
         }
         STORE2x8(c00,c01,c02,c03,c04,c05,c06,c07,c10,c11,c12,c13,c14,c15,c16,c17,cp0,Cstride);
         b0 += Bstride*8;
         cp0 += 8;
      }
      if (n_marg_el & 0x4) {
         ap0=a0;
         bp0_0 = b0;
         bp0_1 = bp0_0 + Bstride;
         bp0_2 = bp0_1 + Bstride;
         bp0_3 = bp0_2 + Bstride;
         LOAD2x4(c00,c01,c02,c03,c10,c11,c12,c13,cp0,Cstride);
         for (; ap0!=ap0_endp; bp0_0+=4,bp0_1+=4,bp0_2+=4,bp0_3+=4) {
            mul_tmf2x4tmf4x4_mf2x4(c00,c01,c02,c03,c10,c11,c12,c13,ap0,Astride,bp0_0,bp0_1,bp0_2,bp0_3);
         }
         if (k_marg_el & 0x2) {
            mul_tmf2x2tmf2x4_mf2x4(c00,c01,c02,c03,c10,c11,c12,c13,ap0,Astride,bp0_0,bp0_1,bp0_2,bp0_3);
            bp0_0+=2;bp0_1+=2;bp0_2+=2;bp0_3+=2;
         }
         if (k_marg_el & 0x1) {
            mul_tmf2x1tmf1x4_mf2x4(c00,c01,c02,c03,c10,c11,c12,c13,ap0,Astride,bp0_0,bp0_1,bp0_2,bp0_3);
         }
         STORE2x4(c00,c01,c02,c03,c10,c11,c12,c13,cp0,Cstride);
         b0 += Bstride*4;
         cp0 += 4;
      }
      if (n_marg_el & 0x2) {
         ap0=a0;
         bp0_0 = b0;
         bp0_1 = bp0_0 + Bstride;
         LOAD2x2(c00,c01,c10,c11,cp0,Cstride);
         for (; ap0!=ap0_endp; bp0_0+=4,bp0_1+=4) {
            mul_tmf2x4tmf4x2_mf2x2(c00,c01,c10,c11,ap0,Astride,bp0_0,bp0_1);
         }
         if (k_marg_el & 0x2) {
            mul_tmf2x2tmf2x2_mf2x2(c00,c01,c10,c11,ap0,Astride,bp0_0,bp0_1);
            bp0_0+=2;bp0_1+=2;
         }
         if (k_marg_el & 0x1) {
            mul_tmf2x1tmf1x2_mf2x2(c00,c01,c10,c11,ap0,Astride,bp0_0,bp0_1);
         }
         STORE2x2(c00,c01,c10,c11,cp0,Cstride);
         b0 += Bstride*2;
         cp0 += 2;
      }
      if (n_marg_el & 0x1) {
         ap0=a0;
         bp0_0 = b0;
         LOAD2x1(c00,c10,cp0,Cstride);
         for (; ap0!=ap0_endp; bp0_0+=4) {
            mul_tmf2x4tmf4x1_mf2x1(c00,c10,ap0,Astride,bp0_0);
         }
         if (k_marg_el & 0x2) {
            mul_tmf2x2tmf2x1_mf2x1(c00,c10,ap0,Astride,bp0_0);
            bp0_0+=2;
         }
         if (k_marg_el & 0x1) {
            mul_tmf2x1tmf1x1_mf2x1(c00,c10,ap0,Astride,bp0_0);
         }
         STORE2x1(c00,c10,cp0,Cstride);
      }
   }
   if (m_marg_el & 0x1) {
      const float* const ap0_endp = a0 + k_norm;
      float* const cp0_endp = c0 + n_norm;
      for (b0=B,cp0=c0; cp0!=cp0_endp; b0+=B_sbs_stride,cp0+=10) {
         ap0=a0;
         bp0_0 = b0;
         bp0_1 = bp0_0 + Bstride;
         bp0_2 = bp0_1 + Bstride;
         bp0_3 = bp0_2 + Bstride;
         bp0_4 = bp0_3 + Bstride;
         bp0_5 = bp0_4 + Bstride;
         bp0_6 = bp0_5 + Bstride;
         bp0_7 = bp0_6 + Bstride;
         bp0_8 = bp0_7 + Bstride;
         bp0_9 = bp0_8 + Bstride;
         LOAD1x10(c00,c01,c02,c03,c04,c05,c06,c07,c08,c09,cp0,Cstride);
         for (; ap0!=ap0_endp; bp0_0+=4,bp0_1+=4,bp0_2+=4,bp0_3+=4,bp0_4+=4,bp0_5+=4,bp0_6+=4,bp0_7+=4,bp0_8+=4,bp0_9+=4) {
            mul_tmf1x4tmf4x10_mf1x10(c00,c01,c02,c03,c04,c05,c06,c07,c08,c09,ap0,Astride,bp0_0,bp0_1,bp0_2,bp0_3,bp0_4,bp0_5,bp0_6,bp0_7,bp0_8,bp0_9);
         }
         if (k_marg_el & 0x2) {
            mul_tmf1x2tmf2x10_mf1x10(c00,c01,c02,c03,c04,c05,c06,c07,c08,c09,ap0,Astride,bp0_0,bp0_1,bp0_2,bp0_3,bp0_4,bp0_5,bp0_6,bp0_7,bp0_8,bp0_9);
            bp0_0+=2;bp0_1+=2;bp0_2+=2;bp0_3+=2;bp0_4+=2;bp0_5+=2;bp0_6+=2;bp0_7+=2;bp0_8+=2;bp0_9+=2;
         }
         if (k_marg_el & 0x1) {
            mul_tmf1x1tmf1x10_mf1x10(c00,c01,c02,c03,c04,c05,c06,c07,c08,c09,ap0,Astride,bp0_0,bp0_1,bp0_2,bp0_3,bp0_4,bp0_5,bp0_6,bp0_7,bp0_8,bp0_9);
         }
         STORE1x10(c00,c01,c02,c03,c04,c05,c06,c07,c08,c09,cp0,Cstride);
      }
      if (n_marg_el & 0x8) {
         ap0=a0;
         bp0_0 = b0;
         bp0_1 = bp0_0 + Bstride;
         bp0_2 = bp0_1 + Bstride;
         bp0_3 = bp0_2 + Bstride;
         bp0_4 = bp0_3 + Bstride;
         bp0_5 = bp0_4 + Bstride;
         bp0_6 = bp0_5 + Bstride;
         bp0_7 = bp0_6 + Bstride;
         LOAD1x8(c00,c01,c02,c03,c04,c05,c06,c07,cp0,Cstride);
         for (; ap0!=ap0_endp; bp0_0+=4,bp0_1+=4,bp0_2+=4,bp0_3+=4,bp0_4+=4,bp0_5+=4,bp0_6+=4,bp0_7+=4) {
            mul_tmf1x4tmf4x8_mf1x8(c00,c01,c02,c03,c04,c05,c06,c07,ap0,Astride,bp0_0,bp0_1,bp0_2,bp0_3,bp0_4,bp0_5,bp0_6,bp0_7);
         }
         if (k_marg_el & 0x2) {
            mul_tmf1x2tmf2x8_mf1x8(c00,c01,c02,c03,c04,c05,c06,c07,ap0,Astride,bp0_0,bp0_1,bp0_2,bp0_3,bp0_4,bp0_5,bp0_6,bp0_7);
            bp0_0+=2;bp0_1+=2;bp0_2+=2;bp0_3+=2;bp0_4+=2;bp0_5+=2;bp0_6+=2;bp0_7+=2;
         }
         if (k_marg_el & 0x1) {
            mul_tmf1x1tmf1x8_mf1x8(c00,c01,c02,c03,c04,c05,c06,c07,ap0,Astride,bp0_0,bp0_1,bp0_2,bp0_3,bp0_4,bp0_5,bp0_6,bp0_7);
         }
         STORE1x8(c00,c01,c02,c03,c04,c05,c06,c07,cp0,Cstride);
         b0 += Bstride*8;
         cp0 += 8;
      }
      if (n_marg_el & 0x4) {
         ap0=a0;
         bp0_0 = b0;
         bp0_1 = bp0_0 + Bstride;
         bp0_2 = bp0_1 + Bstride;
         bp0_3 = bp0_2 + Bstride;
         LOAD1x4(c00,c01,c02,c03,cp0,Cstride);
         for (; ap0!=ap0_endp; bp0_0+=4,bp0_1+=4,bp0_2+=4,bp0_3+=4) {
            mul_tmf1x4tmf4x4_mf1x4(c00,c01,c02,c03,ap0,Astride,bp0_0,bp0_1,bp0_2,bp0_3);
         }
         if (k_marg_el & 0x2) {
            mul_tmf1x2tmf2x4_mf1x4(c00,c01,c02,c03,ap0,Astride,bp0_0,bp0_1,bp0_2,bp0_3);
            bp0_0+=2;bp0_1+=2;bp0_2+=2;bp0_3+=2;
         }
         if (k_marg_el & 0x1) {
            mul_tmf1x1tmf1x4_mf1x4(c00,c01,c02,c03,ap0,Astride,bp0_0,bp0_1,bp0_2,bp0_3);
         }
         STORE1x4(c00,c01,c02,c03,cp0,Cstride);
         b0 += Bstride*4;
         cp0 += 4;
      }
      if (n_marg_el & 0x2) {
         ap0=a0;
         bp0_0 = b0;
         bp0_1 = bp0_0 + Bstride;
         LOAD1x2(c00,c01,cp0,Cstride);
         for (; ap0!=ap0_endp; bp0_0+=4,bp0_1+=4) {
            mul_tmf1x4tmf4x2_mf1x2(c00,c01,ap0,Astride,bp0_0,bp0_1);
         }
         if (k_marg_el & 0x2) {
            mul_tmf1x2tmf2x2_mf1x2(c00,c01,ap0,Astride,bp0_0,bp0_1);
            bp0_0+=2;bp0_1+=2;
         }
         if (k_marg_el & 0x1) {
            mul_tmf1x1tmf1x2_mf1x2(c00,c01,ap0,Astride,bp0_0,bp0_1);
         }
         STORE1x2(c00,c01,cp0,Cstride);
         b0 += Bstride*2;
         cp0 += 2;
      }
      if (n_marg_el & 0x1) {
         ap0=a0;
         bp0_0 = b0;
         LOAD1x1(c00,cp0,Cstride);
         for (; ap0!=ap0_endp; bp0_0+=4) {
            mul_tmf1x4tmf4x1_mf1x1(c00,ap0,Astride,bp0_0);
         }
         if (k_marg_el & 0x2) {
            mul_tmf1x2tmf2x1_mf1x1(c00,ap0,Astride,bp0_0);
            bp0_0+=2;
         }
         if (k_marg_el & 0x1) {
            mul_tmf1x1tmf1x1_mf1x1(c00,ap0,Astride,bp0_0);
         }
         STORE1x1(c00,cp0,Cstride);
      }
   }
}

/* Fixed M,K,N = 52,52,50 L1-blocked matrix matrix multiply. */
void
_multtacc_mfmf_mf_l1(const float *const A, const float *const B, float *const C, const int Astride, const int Bstride, const int Cstride)
{
   const float *a0,*b0;
   float *c0;
   const float *ap0;
   const float *bp0_0,*bp0_1,*bp0_2,*bp0_3,*bp0_4,*bp0_5,*bp0_6,*bp0_7,*bp0_8,*bp0_9;
   float *cp0;
   const int B_sbs_stride = Bstride*10;
   const int C_sbs_stride = Cstride*2;
   const int k_norm = 52*Astride;
   float *const c0_endp = C+52*Cstride;
   register float c00,c01,c02,c03,c04,c05,c06,c07,c08,c09,c10,c11,c12,c13,c14,c15,c16,c17,c18,c19;
   for (c0=C,a0=A; c0!= c0_endp; c0+=C_sbs_stride,a0+=2) {
      const float* const ap0_endp = a0 + k_norm;
      float* const cp0_endp = c0 + 50;
      for (b0=B,cp0=c0; cp0!=cp0_endp; b0+=B_sbs_stride,cp0+=10) {
         ap0=a0;
         bp0_0 = b0;
         bp0_1 = bp0_0 + Bstride;
         bp0_2 = bp0_1 + Bstride;
         bp0_3 = bp0_2 + Bstride;
         bp0_4 = bp0_3 + Bstride;
         bp0_5 = bp0_4 + Bstride;
         bp0_6 = bp0_5 + Bstride;
         bp0_7 = bp0_6 + Bstride;
         bp0_8 = bp0_7 + Bstride;
         bp0_9 = bp0_8 + Bstride;
         LOAD2x10(c00,c01,c02,c03,c04,c05,c06,c07,c08,c09,c10,c11,c12,c13,c14,c15,c16,c17,c18,c19,cp0,Cstride);
         for (; ap0!=ap0_endp; bp0_0+=4,bp0_1+=4,bp0_2+=4,bp0_3+=4,bp0_4+=4,bp0_5+=4,bp0_6+=4,bp0_7+=4,bp0_8+=4,bp0_9+=4) {
            mul_tmf2x4tmf4x10_mf2x10(c00,c01,c02,c03,c04,c05,c06,c07,c08,c09,c10,c11,c12,c13,c14,c15,c16,c17,c18,c19,ap0,Astride,bp0_0,bp0_1,bp0_2,bp0_3,bp0_4,bp0_5,bp0_6,bp0_7,bp0_8,bp0_9);
         }
         STORE2x10(c00,c01,c02,c03,c04,c05,c06,c07,c08,c09,c10,c11,c12,c13,c14,c15,c16,c17,c18,c19,cp0,Cstride);
      }
   }
}

void
_multtacc_mfmf_mf(const int M, const int K, const int N, const float *const A, const float *const B, float *const C, const int Astride, const int Bstride, const int Cstride)
{
   /* Code for L2-blocked routine. */
   int m2,k2,n2;
   const float *a2,*b2;
   float *c2;
   const float *ap2,*bp2;
   float *cp2;
   if (M < 53 && K < 53 && N < 51) {
      _multtacc_mfmf_mf_l1_arb_all(M,K,N,A,B,C,Astride,Bstride,Cstride);
      return;
   }
   for (m2=0; m2<=M-52; m2+=52) {
      c2 = C + m2*Cstride;
      a2 = A + m2;
      for (n2=0,b2=B,cp2=c2; n2<=N-50; n2+=50,b2+=50*Bstride,cp2+=50) {
         for (k2=0,bp2=b2,ap2=a2; k2<=K-52; k2+=52,bp2+=52,ap2+=52*Astride) {
            _multtacc_mfmf_mf_l1(ap2,bp2,cp2,Astride,Bstride,Cstride);
         }
         if (k2 < K) {
            _multtacc_mfmf_mf_l1_arb_k(K-k2,ap2,bp2,cp2,Astride,Bstride,Cstride);
         }
      }
      if (n2 < N) {
         for (k2=0,bp2=b2,ap2=a2; k2<=K-52; k2+=52,bp2+=52,ap2+=52*Astride) {
            _multtacc_mfmf_mf_l1_arb_all(52,52,N-n2,ap2,bp2,cp2,Astride,Bstride,Cstride);
         }
         if (k2 < K) {
            _multtacc_mfmf_mf_l1_arb_all(52,K-k2,N-n2,ap2,bp2,cp2,Astride,Bstride,Cstride);
         }
      }
   }
   if (m2 < M) {
      c2 = C + m2*Cstride;
      a2 = A + m2;
      for (n2=0,b2=B,cp2=c2; n2<=N-50; n2+=50,b2+=50*Bstride,cp2+=50) {
         for (k2=0,bp2=b2,ap2=a2; k2<=K-52; k2+=52,bp2+=52,ap2+=52*Astride) {
            _multtacc_mfmf_mf_l1_arb_all(M-m2,52,50,ap2,bp2,cp2,Astride,Bstride,Cstride);
         }
         if (k2 < K) {
            _multtacc_mfmf_mf_l1_arb_all(M-m2,K-k2,50,ap2,bp2,cp2,Astride,Bstride,Cstride);
         }
      }
      if (n2 < N) {
         for (k2=0,bp2=b2,ap2=a2; k2<=K-52; k2+=52,bp2+=52,ap2+=52*Astride) {
            _multtacc_mfmf_mf_l1_arb_all(M-m2,52,N-n2,ap2,bp2,cp2,Astride,Bstride,Cstride);
         }
         if (k2 < K) {
            _multtacc_mfmf_mf_l1_arb_all(M-m2,K-k2,N-n2,ap2,bp2,cp2,Astride,Bstride,Cstride);
         }
      }
   }
}


void
php_multtacc_mfmf_mf(size_t a_rows, size_t a_cols, size_t b_rows,
		     const float* a, const float* b, float* res)
{
    _multtacc_mfmf_mf(a_cols, a_rows, b_rows,
		      a, b, res, a_cols, a_rows, b_rows);
}
