/*
** $Header: /u/spert/src/fltvec/wrp/RCS/mat.c,v 1.2 1996/03/22 03:49:35 davidj Exp $
** ** Matrix routines made from simpler routines.
*/

#include <fltv-config.h>
#include <stddef.h>
#include <math.h>
#include <fltv-defs.h>
#include <fltv-scansrc.h>

/****************************************************************/
/* Copy an unstrided matrix to a strided matrix */
/****************************************************************/

#ifdef DECL_wrp_copy_mf_smf
void wrp_copy_mf_smf(size_t height, size_t in_width, size_t stride,
		    const float* from, float* to);
#endif

#ifdef DEFN_wrp_copy_mf_smf
void
wrp_copy_mf_smf(size_t height, size_t in_width, size_t stride,
	       const float* from, float* to)
{
    size_t i;

    for (i=0; i<height; i++)
    {
	copy_vf_vf(in_width, from, to);
	from += in_width;
	to += stride;
    }
}
#endif /* #ifdef DEFN_wrp_copy_mf_smf */

/****************************************************************/
/* Copy a strided matrix to an unstrided matrix */
/****************************************************************/

#ifdef DECL_wrp_copy_smf_mf
void wrp_copy_smf_mf(size_t height, size_t width, size_t stride,
		    const float* from, float* to);
#endif

#ifdef DEFN_wrp_copy_smf_mf
void
wrp_copy_smf_mf(size_t height, size_t width, size_t stride,
	       const float* from, float* to)
{
    size_t i;

    for (i=0; i<height; i++)
    {
	copy_vf_vf(width, from, to);
	from += stride;
	to += width;
    }
}
#endif /* #ifdef DEFN_wrp_copy_smf_mf */

